//cmpu102 spring 2020
//perfectly proper practice with priority queues!
//
import java.util.*;

public class PQ {


  public static void main(String[] args) {

    // make a priority queue of strings
    // will use the compareTo method built in to strings
    PriorityQueue<String> pq = new PriorityQueue<String>();

    // make a RevCmp object
	// "ReverseCompare"
	// for another view on reverse compare (it uses the c language): 
	// https://stackoverflow.com/questions/57022354/how-can-i-compare-two-strings-by-more-than-just-one-character
	// we will take a closer look at this in the lectcure notes
    // this object defines a compare method that compares strings differently
    RevCmp rcmp = new RevCmp();    

    // make a priority queue of strings that uses RevCmp to compare them
    PriorityQueue<String> pqr = new PriorityQueue<String>(rcmp);

    // add elements to PQ
    pq.add("Anna");
    pq.add("Rui");
    pq.add("Dalia");
    pq.add("Alice");

    // remove elts and print them
    String s = pq.remove();
    String t = pq.remove();
    String k = pq.remove();
    String y = pq.remove();
    System.out.println("Part 1, display of elements removed from queue");
    System.out.println(s);
    System.out.println(t);
    System.out.println(k);
    System.out.println(y);
    System.out.println("the priority queue pq is now empty");

    System.out.println("\n\n");

    // make array of strings
    String[] array = {"Emily", "Rachel", "Irene", "Rick", "Alex", "Dustin", "Liam"};

    System.out.println("print the strings in the array");
    for (int i = 0; i < array.length; i++)
        System.out.println(array[i]);

    System.out.println("\n\n");

    System.out.println("we want to sort the array of strings in alphabetical order");

    System.out.println("... put all strings in array into priority queue pq");
    for (int i = 0; i < array.length; i++)
        pq.add(array[i]);

    //  FACT: if we remove from pq, we will get highest priority element (1st in alphabetical order)
    for (int i = 0; i < array.length; i++)
        array[i] = pq.remove();

    System.out.println("printed array will have strings in alphabetical order");
    for (int i = 0; i < array.length; i++)
        System.out.println(array[i]);

    System.out.println("\n\n");

    System.out.println("if want to sort strings in REVERSE alphabetical order...");

    System.out.println("... put all strings in array into priority queue pqr and use RevCmp");
    for (int i = 0; i < array.length; i++)
        pqr.add(array[i]);

    //  FACT: if we remove from pqr, we will get highest priority element (last in alphabetical order)
    //  this is because priority queue pqr uses the reverse comparator
    for (int i = 0; i < array.length; i++)
        array[i] = pqr.remove();

    System.out.println(" the printed array will have strings in reverse alphabetical order");
    for (int i = 0; i < array.length; i++)
        System.out.println(array[i]);

  }

}